package com.brilliance.isc.funds.common.controller;

import com.brilliance.isc.bo.Bch;
import com.brilliance.isc.bo.Pta;
import com.brilliance.isc.common.api.bch.service.BchService;
import com.brilliance.isc.common.cache.pta.PtaCacheService;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.util.StringUtils;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.bo.funds.FttfcmStoreBo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.funds.transfer.transaction.FttfcmStructMapper;
import com.brilliance.isc.funds.vo.funds.FttfcmStoreVo;
import com.brilliance.isc.vo.ResponseSet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/getRef")
public class RefController {

    @Autowired
    private BchService bchService;

    @Autowired
    private PtaCacheService ptaCacheService;

    @Resource
    private SettleContext settleContext;

    @Resource
    private FtToolComponent ftToolComponent;

    @Resource
    private FttfcmStructMapper fttfcmStructMapper;


    @PostMapping("/ftt")
    public ResponseSet<String> getRef(@RequestBody FttfcmStoreVo fttfcmStoreVo) {
        FttfcmStoreBo fttfcmStoreBo= fttfcmStructMapper.voTransferToBo(fttfcmStoreVo);
        fttfcmStoreBo.reset();

        //已有ownref
        if (StringUtils.isNotEmpty(fttfcmStoreBo.getFtdgrp().getRec().getOwnref())){
            return ResponseSet.simpleSuccess(fttfcmStoreBo.getFtdgrp().getRec().getOwnref());
        }

        //Tro.ptainr为空
        PtsptaVo ptsptaVo = fttfcmStoreBo.getFtdgrp().getTro();
        if (ptsptaVo == null || StringUtils.isEmpty(ptsptaVo.getPtainr())) {
            return ResponseSet.fail("无效的客户号,请检查是否为我行客户");
            //SettleContext.getUserSession().setWrkbch(SettleContext.getUserSession().getBch());
        }

        //pta.Branchinr
        Pta pta = ptaCacheService.getPtaByInr(ptsptaVo.getPtainr());
        if (pta == null || StringUtils.isEmpty(pta.getBranchinr())) {
            return ResponseSet.fail("无效的客户号,请检查是否为我行客户和客户归属机构");
        }

        settleContext.loadSettleSession("", pta.getBranchinr(), "");
        //检查归属机构的机构号是否存在
        Bch wrkbch = SettleContext.getUserSession().getWrkbch();
        if (wrkbch == null || StringUtils.isEmpty(wrkbch.getBchflg())) {
            return ResponseSet.fail("客户所属机构未配置完整，请联系系统管理员，pta.branchinr="+pta.getBranchinr());
        }

        ftToolComponent.getref(fttfcmStoreBo.getFtdgrp());
        String ref = fttfcmStoreBo.getFtdgrp().getRec().getOwnref();
        return ResponseSet.simpleSuccess(ref);
    }
}
